VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   4170
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7830
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4170
   ScaleWidth      =   7830
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   495
      Left            =   6480
      TabIndex        =   4
      Top             =   3480
      Width           =   1215
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Delete"
      Height          =   495
      Index           =   2
      Left            =   6480
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   3855
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   6135
      _ExtentX        =   10821
      _ExtentY        =   6800
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   5
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Group"
         Object.Width           =   1764
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   2
         SubItemIndex    =   2
         Text            =   "Ball"
         Object.Width           =   1764
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   2
         SubItemIndex    =   3
         Text            =   "Activ"
         Object.Width           =   1764
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   4
         Text            =   "Stip"
         Object.Width           =   882
      EndProperty
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Add"
      Height          =   495
      Index           =   0
      Left            =   6480
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Edit"
      Height          =   495
      Index           =   1
      Left            =   6480
      TabIndex        =   2
      Top             =   720
      Width           =   1215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private aData() As Variant
Private stip() As Single

Public Enum EFields
    FIndx = 0
    FName = 1
    FTest1 = 2
    FTest2 = 3
    FTest3 = 4
    FTest4 = 5
    FTest5 = 6
    FActiv = 7
End Enum

Const SNone As Single = 0
Const SNormal As Single = 1#
Const SBonus25 As Single = 1.25
Const SBonus50 As Single = 1.5

Private NoData As Boolean
Private SelIndex As Long
Private ItemClick As Boolean

Private Sub cmdAction_Click(Index As Integer)
    
    Dim SelRec As Long
    
    If (Index = 0) Then
        If (AddRec) Then Call RefreshList(UBound(aData))
    Else
        If (ListView1.SelectedItem Is Nothing) Then Exit Sub
        SelRec = ListView1.SelectedItem.Index - 1
        If (Index = 1) Then
            If (EditRec(SelRec)) Then Call RefreshList(SelRec)
        Else
            If (DelRec(SelRec)) Then Call RefreshList(SelRec - 1)
        End If
    End If
End Sub

Private Sub cmdSave_Click()
    Call SaveData
End Sub

Private Sub Form_Load()
    NoData = (Not LoadData)
    Call RefreshList(-1)
End Sub

Private Function LoadData() As Boolean
    
    On Error GoTo ExitRoutine
    
    Dim iFF As Long
    Dim s As String
    Dim i As Long
    Dim tmp
    
    iFF = FreeFile()
    Open App.Path & "\data.txt" For Input As #iFF
    s = Input(LOF(iFF), iFF)
    Close #iFF
    
    tmp = Split(s, vbCrLf)
    If (UBound(tmp) < 0) Then GoTo ExitRoutine
    
    ReDim aData(0 To UBound(tmp))
    
    For i = 0 To UBound(tmp)
        aData(i) = Split(tmp(i), ";")
    Next
    
    LoadData = True
    
ExitRoutine:
End Function

Private Function SaveData()
    
    Dim iFF As Long
    Dim i As Long
    Dim tmp() As String
    
    If (NoData) Then Exit Function
    
    ReDim tmp(0 To UBound(aData))
    
    For i = 0 To UBound(aData)
        tmp(i) = Join(aData(i), ";")
    Next
    
    iFF = FreeFile()
    Open App.Path & "\data.txt" For Output As #iFF
    Print #iFF, Join(tmp, vbCrLf);
    Close #iFF
    
End Function

Private Function AddRec() As Boolean
    
    Dim Rec() As Variant
    
    ReDim Rec(0 To 7)
    
    If (frmNewRec.EditRec(Rec)) Then
        AddRec = True
        If (NoData) Then
            ReDim aData(0 To 0)
            NoData = False
        Else
            ReDim Preserve aData(0 To UBound(aData) + 1)
        End If
        aData(UBound(aData)) = Rec
    End If
    
    Erase Rec
End Function

Private Function EditRec(ByVal Index As Long) As Boolean
    
    Dim Rec As Variant
    
    Rec = aData(Index)
    
    If (frmNewRec.EditRec(Rec)) Then
        EditRec = True
        aData(Index) = Rec
    End If
    
End Function

Private Function DelRec(ByVal Index As Long) As Boolean
    
    Dim i As Long
    
    If (MsgBox("Delete this record?", vbQuestion + vbYesNo) = vbYes) Then
        DelRec = True
        For i = Index To UBound(aData) - 1
            aData(i) = aData(i + 1)
        Next
        ReDim Preserve aData(0 To UBound(aData) - 1)
    End If
    
End Function

Private Sub Calculate()
    
    Dim i As Long
    Dim j As Long
    Dim ball As Long
    Dim min As Long
    Dim count3 As Long
    
    If (NoData) Then Exit Sub
    
    ReDim stip(0 To UBound(aData))
    
    For i = 0 To UBound(aData)
        
        min = 5
        count3 = 0
        For j = FTest1 To FTest5
            ball = Val(aData(i)(j))
            If (min > ball) Then min = ball
            If (ball = 3) Then count3 = count3 + 1
        Next
        
        stip(i) = SNone
        Select Case min
        Case 5
            If (aData(i)(FActiv)) Then
                stip(i) = SBonus50
            Else
                stip(i) = SBonus25
            End If
        Case 4
            stip(i) = SNormal
        Case 3
            If (count3 = 1) Then
                If (aData(i)(FActiv)) Then stip(i) = SNormal
            End If
        End Select
    Next
    
End Sub

Private Sub RefreshList(ByVal Index As Long)
    
    Dim i As Long, j As Long
    Dim ListItem As MSComctlLib.ListItem
    
    Call Calculate
    With ListView1.ListItems
        .Clear
        If (NoData) Then Exit Sub
        For i = 0 To UBound(aData)
            Set ListItem = .Add(, , aData(i)(FIndx))
            With ListItem
                .SubItems(1) = aData(i)(FName)
                For j = FTest1 To FTest5
                    .SubItems(2) = Trim$(.SubItems(2) & " " & Val(aData(i)(j)))
                Next
                .SubItems(3) = aData(i)(FActiv)
                .SubItems(4) = stip(i)
                If (.Index = Index + 1) Then .Selected = True
            End With
        Next
    End With
    
End Sub

Private Sub ListView1_Click()
    If (Not ItemClick) Then SelIndex = -1
    ItemClick = False
End Sub

Private Sub ListView1_DblClick()
    Dim Index As Long
    If (SelIndex < 0) Then Exit Sub
    Index = SelIndex
    If (EditRec(Index)) Then Call RefreshList(Index)
End Sub

Private Sub ListView1_ItemClick(ByVal Item As MSComctlLib.ListItem)
    SelIndex = Item.Index - 1
    ItemClick = True
End Sub

Private Sub ListView1_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim Index As Long
    If (SelIndex < 0) Then Exit Sub
    If (KeyCode = 46) Then
        Index = SelIndex
        If (DelRec(Index)) Then Call RefreshList(Index - 1)
    End If
End Sub

Private Sub ListView1_KeyPress(KeyAscii As Integer)
    Dim Index As Long
    If (SelIndex < 0) Then Exit Sub
    If (KeyAscii = 13) Then
        Index = SelIndex
        If (EditRec(Index)) Then Call RefreshList(Index)
    End If
End Sub
